Class INFIL_3rdWeapon extends Actor
	Transient;

struct FMeshVertList
{
	var() int iVerts[3];
	var() Mesh Mesh;
};
var() array<FMeshVertList> VList;
var int Verts[3];
var() rotator RotOffset;
var() float ZDepth;
var vector RotX,RotY,RotZ;
var class<INFIL_Weapon> RepClass;
var Actor ActorOwner;
var bool bHasBeenInit;

replication
{
	reliable if( Role==ROLE_Authority )
		RepClass,ActorOwner;
}

function PostBeginPlay()
{
	ActorOwner = Owner;
	InitPose();
}
simulated final function InitPose()
{
	local byte i,j;

	for( i=0; i<Array_Size(Default.VList); ++i )
		if( Default.VList[i].Mesh==ActorOwner.Mesh )
		{
			for( j=0; j<3; ++j )
				Verts[j] = Default.VList[i].iVerts[j];
			bHasBeenInit = true;
			GetAxes(RotOffset,RotX,RotY,RotZ);
			return;
		}
	Destroy();
}
simulated function PostNetBeginPlay()
{
	if( RepClass!=None )
	{
		Mesh = RepClass.Default.PickupViewMesh;
		DrawScale = RepClass.Default.PickupViewScale;
	}
}
simulated function Tick( float Delta )
{
	if( ActorOwner==None || ActorOwner.bDeleteMe )
	{
		if( Level.NetMode==NM_Client )
			DrawType = DT_None;
		else Destroy();
		return;
	}
	if( Level.NetMode==NM_DedicatedServer )
	{
		SetLocation(ActorOwner.Location);
		return;
	}
	if( !bHasBeenInit )
		InitPose();
	if( (Level.TimeSeconds-ActorOwner.LastRenderedTime)<1.f )
	{
		DrawType = DT_Mesh;
		SetupPosition();
	}
	else
	{
		DrawType = DT_None;
		SetLocation(ActorOwner.Location);
	}
}
simulated final function SetupPosition()
{
	local vector V,X,Y,Z;
	local rotator R;

	V = ActorOwner.GetVertexPos(Verts[0],true);
	X = Normal(ActorOwner.GetVertexPos(Verts[1],true)-V);
	Y = Normal(ActorOwner.GetVertexPos(Verts[2],true)-V);
	Z = X Cross Y;
	SetLocation(V+Z*ZDepth);
	R = OrthoRotation(X,Y,Z);
	SetRotation(OrthoRotation(RotX >> R,RotY >> R,RotZ >> R));
}

defaultproperties
{
				VList(0)=(iVerts[0]=208,iVerts[1]=94,iVerts[2]=5,Mesh=LodMesh'UnrealI.Male1')
				VList(1)=(iVerts[0]=236,iVerts[1]=142,iVerts[2]=21,Mesh=LodMesh'UnrealI.Male2')
				VList(2)=(iVerts[0]=234,iVerts[1]=163,iVerts[2]=48,Mesh=LodMesh'UnrealShare.Male3')
				VList(3)=(iVerts[0]=258,iVerts[1]=155,iVerts[2]=57,Mesh=LodMesh'UnrealShare.Female1')
				VList(4)=(iVerts[0]=250,iVerts[1]=187,iVerts[2]=56,Mesh=LodMesh'UnrealI.Female2')
				VList(5)=(iVerts[0]=260,iVerts[1]=215,iVerts[2]=82,Mesh=LodMesh'UnrealI.Nali2')
				VList(6)=(iVerts[0]=126,iVerts[1]=55,iVerts[2]=30,Mesh=LodMesh'UnrealI.sktrooper')
				RotOffset=(Pitch=-2400,Yaw=6000)
				ZDepth=3.000000
				RemoteRole=ROLE_SimulatedProxy
				bCarriedItem=True
				bSkipActorReplication=True
				bRepAnimations=False
				bRepAmbientSound=False
				NetUpdateFrequency=10.000000
}
